<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Mixing example</TITLE>
<link href="builder_26.html" rel=Next>
<link href="builder_24.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_24.html">previous</A>, <A HREF="builder_26.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC56" HREF="builder_toc.html#TOC56">Example of Mixing SUIF with Builder</A></H2>

<PRE>
     void Tile(tree_for * tf, int tile_size)
     {
        block ind(tf-&#62;index());        { the index variable }
        block lb(tf-&#62;lb_op());         { operands for bounds }
        block ub(tf-&#62;ub_op());
        block body(tf-&#62;body(), FALSE); { tree_node_list of the body }
        block blksz(tile_size);
        block drv_ind(block::new_sym(cst_int, "driver_ind"));
        block inner_loop(block::FOR(ind,
                             block::max(lb, blksz*drv_ind),
                             block::min(ub, blksz*drv_ind+blksz-block(1)),
                                    body));
        block outer_loop(block::FOR(drv_ind,
                                    lb/blksz,
                                    (ub+blksz-1)/blksz,
                                    inner_loop);

        tree_for * new_tf = (tree_for *)outer_loop.make_tree_node(tf);
        tf-&#62;parent()-&#62;insert_after(new_tf, tf-&#62;list_e());
        tf-&#62;parent()-&#62;remove(tf-&#62;list_e());
     }
</PRE>

<P>
<A NAME="IDX139"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_24.html">previous</A>, <A HREF="builder_26.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
